--- check_ping.c	Sat Feb 15 10:48:45 2003
+++ check_ping-interface.c	Tue Sep 16 13:16:23 2003
@@ -19,7 +19,7 @@
 
 #define OPTIONS "\
 -H <host_address> -w <wrta>,<wpl>%% -c <crta>,<cpl>%%\n\
-       [-p packets] [-t timeout] [-L]\n"
+       [-p packets] [-t timeout] [-L] [-I interface]\n"
 
 #define LONGOPTIONS "\
 -H, --hostname=HOST\n\
@@ -36,7 +36,9 @@
    show HTML in the plugin output (obsoleted by urlize)\n\
 THRESHOLD is <rta>,<pl>%% where <rta> is the round trip average travel\n\
 time (ms) which triggers a WARNING or CRITICAL state, and <pl> is the\n\
-percentage of packet loss to trigger an alarm state.\n"
+percentage of packet loss to trigger an alarm state.\n\
+-I, --interface=IFACE\n\
+   specify which interface to use when sending icmp ping packets\n"
 
 #define DESCRIPTION "\
 This plugin uses the ping command to probe the specified host for packet loss\n\
@@ -68,6 +70,7 @@
 float wrta = UNKNOWN_TRIP_TIME;
 float crta = UNKNOWN_TRIP_TIME;
 char *server_address = NULL;
+char *iface = "eth0";
 int max_packets = -1;
 int verbose = FALSE;
 
@@ -88,9 +91,9 @@
 
 	/* does the host address of number of packets argument come first? */
 #ifdef PING_PACKETS_FIRST
-	asprintf (&command_line, PING_COMMAND, max_packets, server_address);
+	asprintf (&command_line, PING_COMMAND, max_packets, server_address, iface);
 #else
-	asprintf (&command_line, PING_COMMAND, server_address, max_packets);
+	asprintf (&command_line, PING_COMMAND, server_address, max_packets, iface);
 #endif
 
 	/* Set signal handling and alarm */
@@ -157,11 +160,12 @@
 		{"packets", required_argument, 0, 'p'},
 		{"nohtml", no_argument, 0, 'n'},
 		{"link", no_argument, 0, 'L'},
-		{0, 0, 0, 0}
+		{"interface", no_argument, NULL, 'I'},
+		{0, 0, 0}
 	};
 #endif
 
-#define OPTCHARS "Vvht:c:w:H:p:nL"
+#define OPTCHARS "Vvht:c:w:H:p:nLI:"
 
 	if (argc < 2)
 		return ERROR;
@@ -220,6 +224,9 @@
 		case 'w':
 			get_threshold (optarg, &wrta, &wpl);
 			break;
+		case 'I':	/* ping interface */
+			iface = optarg;
+			break;
 		}
 	}
 
